<template>
  <div>
    <h2>{{ heading }}</h2>

    <div class="mt-2">
      <v-text-field
        ref="firstElement"
        v-validate="'required|max:20'"
        :value="firstName"
        @change="firstName = $event"
        :counter="20"
        :error-messages="errors.collect('firstName')"
        label="Imię"
        data-vv-as="Imię"
        data-vv-name="firstName"
        required
      ></v-text-field>

      <v-text-field
        v-validate="'required|max:30'"
        :value="lastName"
        @change="lastName = $event"
        :counter="30"
        :error-messages="errors.collect('lastName')"
        label="Nazwisko"
        data-vv-as="Nazwisko"
        data-vv-name="lastName"
        required
      ></v-text-field>

      <v-text-field
        v-validate="'required|max:30'"
        :value="street"
        @change="street = $event"
        :counter="30"
        :error-messages="errors.collect('street')"
        label="Ulica"
        data-vv-as="Ulica"
        data-vv-name="street"
        required
      ></v-text-field>

      <v-text-field
        v-validate="'required|max:10'"
        :value="flatNumber"
        @change="flatNumber = $event"
        :counter="10"
        :error-messages="errors.collect('flatNumber')"
        label="Numer mieszkania"
        data-vv-as="Numer mieszkania"
        data-vv-name="flatNumber"
        required
      ></v-text-field>

      <v-text-field
        v-validate="{ required: true, max: 6, regex: /[0-9]{2}-[0-9]{3}$/ }"
        :value="postcode"
        @change="postcode = $event"
        :counter="6"
        :error-messages="errors.collect('postcode')"
        label="Kod pocztowy"
        data-vv-as="Kod pocztowy"
        data-vv-name="postcode"
        required
      ></v-text-field>

      <v-text-field
        v-validate="'required|max:30'"
        :value="city"
        @change="city = $event"
        :counter="30"
        :error-messages="errors.collect('city')"
        label="Miasto"
        data-vv-as="Miasto"
        data-vv-name="city"
        required
      ></v-text-field>
    </div>
  </div>
</template>


<script>
export default {
  inject: ['parentValidator'],
  data() {
    return {
      heading: 'Dane pracownika',
    };
  },
  computed: {
    firstName: {
      get() { return this.$store.getters['form/employee/getFirstName']; },
      set(value) { this.$store.dispatch('form/employee/setFirstName', value); },
    },
    lastName: {
      get() { return this.$store.getters['form/employee/getLastName']; },
      set(value) { this.$store.dispatch('form/employee/setLastName', value); },
    },
    street: {
      get() { return this.$store.getters['form/employee/getStreet']; },
      set(value) { this.$store.dispatch('form/employee/setStreet', value); },
    },
    flatNumber: {
      get() { return this.$store.getters['form/employee/getFlatNumber']; },
      set(value) { this.$store.dispatch('form/employee/setFlatNumber', value); },
    },
    city: {
      get() { return this.$store.getters['form/employee/getCity']; },
      set(value) { this.$store.dispatch('form/employee/setCity', value); },
    },
    postcode: {
      get() { return this.$store.getters['form/employee/getPostcode']; },
      set(value) { this.$store.dispatch('form/employee/setPostcode', value); },
    },
  },
  created() {
    this.$validator = this.parentValidator;
  },
  mounted() {
    this.$refs.firstElement.focus();
  },
};
</script>
